<template>
  <q-card
    flat
    class="q-pa-lg q-my-sm rounded-borders-10 cursor-pointer"
    @click="onClickViewDetails(job.id)"
    style="max-width: 605px; height: 100%"
    :style="{ width: $q.screen.lt.sm ? '100%' : '95%' }"
  >
    <div class="row">
      <div class="q-mr-lg">
        <q-avatar rounded class="logo-container">
          <span class="title-headline text-white">{{
            job.company_name.slice(0, 1)
          }}</span>
        </q-avatar>
      </div>
      <div class="col q-py-lg">
        <p class="title-headline">{{ job.job_title }}</p>
        <p class="title-8">{{ job.company_name }}</p>
      </div>
    </div>

    <div class="row" :class="{ column: $q.screen.lt.lg }">
      <div class="col q-my-auto">
        <span class="footer text-grey-7"
          >POSTED {{ getDaysPosted(job.created_at) }} DAYS AGO</span
        >
      </div>
      <div class="col" align="right" :class="{ 'q-mt-md': $q.screen.lt.md }">
        <q-btn
          id="apply"
          unelevated
          class="btn-md text-white q-mr-sm"
          :disable="job.is_applied === true"
          :color="job.is_applied === true ? 'light-blue-1' : 'light-blue-10'"
          :text-color="job.is_applied === true ? 'light-blue-10' : 'white'"
          :label="job.is_applied === true ? 'APPLIED' : 'APPLY NOW'"
          @click="onClickApplyNow(job.id)"
          :style="{
            width: $q.screen.lt.sm ? 'calc(100% - 50px ) !important;' : 'auto',
          }"
        />

        <q-btn
          unelevated
          class="btn-md"
          :color="job.is_saved === true ? 'blue-5' : 'grey-4'"
          :icon="
            job.is_saved === true ? 'eva-bookmark' : 'eva-bookmark-outline'
          "
          @click="onClickSaveJob(job.id)"
        />
      </div>
    </div>
  </q-card>

  <!-- DIALOG: APPLY NOW -->
  <q-dialog v-model="showApplyNowDialog">
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1000px; max-width: 80vw"
    >
      <q-btn
        @click="showApplyNowDialog = false"
        size="md"
        flat
        color="black"
        round
        dense
        icon="eva-close"
        class="q-my-lg"
        style="position: absolute; top: -22px; right: 0; z-index: 2"
      />
      <q-card-section>
        <div class="row">
          <div class="col-2" style="width: 100px">
            <div class="logo-container rounded-borders-10">
              <!-- <img alt="Vigan City Logo" src="~assets/logo.svg" /> -->
            </div>
          </div>
          <div class="col-6 q-pl-md">
            <p class="text-weight-bold q-mb-none">Flutter Developer</p>
            <p>Clover Advertising</p>
          </div>
          <div class="col" :class="{ 'col-12 q-mt-md': $q.screen.lt.sm }">
            <div
              class="salary-container rounded-borders-10 bg-grey-2 text-center"
            >
              <span>Salary range not available</span>
            </div>
          </div>
        </div>
      </q-card-section>

      <q-card-section>
        <div class="row">
          <div class="col q-gutter-md">
            <q-badge class="badge" color="white" label="FULL-TIME" />
            <q-badge class="badge" color="white" label="HYBRID" />
            <q-badge class="badge" color="white" label="INTERMEDIATE" />
            <q-badge class="badge" color="white" label="3-5 YEARS EXPERIENCE" />
            <q-badge class="badge" color="white" label="2 VACANCIES" />
          </div>
        </div>
      </q-card-section>

      <q-card-section>
        <div
          class="row"
          :style="{
            'flex-flow': $q.screen.lt.sm ? 'column-reverse' : 'initial',
          }"
        >
          <div
            class="q-gutter-md"
            :class="{ 'col-12': $q.screen.lt.sm, 'col-6': $q.screen.gt.sm }"
          >
            <ul>
              <li>
                Have one or more iOS/Android apps developed with Flutter. Either
                deployed on the AppStore/Google Play or available on Github;
              </li>
              <li>
                Over one year’s developing Flutter applications for mobile
              </li>
              <li>
                Develop features on Android, code review, solutioning, design
                and architecture
              </li>
              <li>Create unit tests and automated tests for applications</li>
              <li>
                Document architecture and design in UML (sequence, component and
                deployment diagrams)
              </li>

              <li>
                Gather requirements from Product team and other stakeholders for
                rapidly implementing application
              </li>

              <li>
                Continuously improve skillset on Android with the changes each
                version
              </li>

              <li>Solution for security and reliability</li>
            </ul>

            <div>
              <p><strong>Experience</strong></p>
              <ul>
                <li>Familiar with MVVM/MVP design</li>

                <li>Functional reactive programming experience</li>

                <li>Unit Testing</li>

                <li>
                  At least 3-5 years experience (as developer) in mobile
                  development
                </li>
              </ul>
            </div>
          </div>

          <div class="col"></div>

          <div
            :class="{
              'col-12 q-mb-lg': $q.screen.lt.sm,
              'col-5': $q.screen.gt.sm,
            }"
          >
            <div>
              <p>CV / RESUME</p>
              <q-file outlined v-model="model" max-file-size="5242880">
                <template v-slot:prepend>
                  <q-icon name="eva-attach-outline" />
                </template>
              </q-file>
            </div>

            <div>
              <p>COVER LETTER</p>
              <q-editor
                v-model="text"
                min-height="10rem"
                min-width="100%"
                :dense="$q.screen.lt.md"
                :toolbar="[]"
              />

              <!-- :toolbar="[
                  ['bold', 'italic', 'strike', 'underline'],
                  ['link'],
                  [
                    {
                      label: $q.lang.editor.align,
                      icon: $q.iconSet.editor.align,
                      fixedLabel: true,
                      list: 'only-icons',
                      options: ['left', 'center', 'right', 'justify'],
                    },
                  ],
                  ['unordered', 'ordered', 'outdent', 'indent'],
                ]" -->
            </div>

            <div>
              <q-card-actions align="right">
                <q-btn
                  id="apply"
                  unelevated
                  size="md"
                  label="APPLY NOW"
                  type="submit"
                  class="btn--shade-2 btn-md text-white q-mr-sm"
                  v-close-popup
                />

                <q-btn
                  unelevated
                  class="btn-md"
                  color="grey-4"
                  icon="eva-bookmark-outline"
                />
              </q-card-actions>
            </div>
          </div>
        </div>
      </q-card-section>

      <div class="row q-px-md">
        <div class="col q-mt-md">
          <span>POSTED 5 DAYS AGO</span>
        </div>
      </div>
    </q-card>
  </q-dialog>

  <!-- DIALOG: VIEW DETAILS -->
  <q-dialog v-model="showViewDetailsDialog">
    <q-card
      flat
      class="q-pa-sm q-mt-lg rounded-borders-10"
      style="width: 1000px; max-width: 80vw"
    >
      <q-card-section>
        <div class="row">
          <div class="col-2">
            <div>
              <q-avatar rounded class="logo-container">
                <span class="title-headline text-white">{{
                  jobsListStore.company_name.slice(0, 1)
                }}</span>
              </q-avatar>
            </div>
          </div>
          <div class="col-6">
            <p>{{ jobsListStore.job.job_title }}</p>
            <p>{{ jobsListStore.job.company_name }}</p>
          </div>
          <div class="col">
            <div
              class="salary-container rounded-borders-10 bg-grey-2 text-center"
            >
              <span>
                {{
                  jobsListStore.job.salary_from || jobsListStore.job.salary_to
                    ? "₱ " +
                      jobsListStore.job.salary_from +
                      " - " +
                      jobsListStore.job.salary_to +
                      " /month"
                    : "Salary range not available"
                }}
              </span>
            </div>
          </div>
        </div>
      </q-card-section>

      <q-card-section
        v-show="
          jobsListStore.job.full_time === true ||
          jobsListStore.job.part_time === true ||
          jobsListStore.job.freelance_or_contract === true ||
          jobsListStore.job.entry_level === true ||
          jobsListStore.job.intermediate === true ||
          jobsListStore.job.expert === true ||
          jobsListStore.job.on_site === true ||
          jobsListStore.job.remote === true ||
          jobsListStore.job.hybrid === true ||
          jobsListStore.job.years_of_experience >= 1 ||
          jobsListStore.job.vacancy_number >= 1
        "
      >
        <div class="row">
          <div class="col q-gutter-md">
            <!-- TAGS FOR JOB TYPE -->
            <q-badge
              v-if="jobsListStore.job.full_time === true"
              class="badge"
              color="white"
              label="FULL-TIME"
            />
            <q-badge
              v-if="jobsListStore.job.part_time === true"
              class="badge"
              color="white"
              label="PART-TIME"
            />
            <q-badge
              v-if="jobsListStore.job.freelance_or_contract === true"
              class="badge"
              color="white"
              label="FREELANCE/CONTRACT"
            />

            <!-- TAGS FOR EXPERIENCE LEVEL -->
            <q-badge
              v-if="jobsListStore.job.entry_level === true"
              class="badge"
              color="white"
              label="ENTRY LEVEL"
            />
            <q-badge
              v-if="jobsListStore.job.intermediate === true"
              class="badge"
              color="white"
              label="INTERMEDIATE"
            />
            <q-badge
              v-if="jobsListStore.job.expert === true"
              outline
              color="secondary"
              label="EXPERT"
            />

            <!-- TAGS FOR OTHERS -->
            <q-badge
              v-if="jobsListStore.job.on_site === true"
              class="badge"
              color="white"
              label="ON-SITE"
            />
            <q-badge
              v-if="jobsListStore.job.remote === true"
              class="badge"
              color="white"
              label="REMOTE"
            />
            <q-badge
              v-if="jobsListStore.job.hybrid === true"
              class="badge"
              color="white"
              label="HYBRID"
            />

            <q-badge class="badge" color="white">{{
              jobsListStore.job.years_of_experience <= 1
                ? jobsListStore.job.years_of_experience + " YEAR EXPERIENCE"
                : jobsListStore.job.years_of_experience + " YEARS EXPERIENCE"
            }}</q-badge>
            <q-badge class="badge" color="white">
              {{
                jobsListStore.job.vacancy_number <= 1
                  ? jobsListStore.job.vacancy_number + " VACANCY"
                  : jobsListStore.job.vacancy_number + " VACANCIES"
              }}
            </q-badge>
          </div>
        </div>
      </q-card-section>

      <q-card-section>
        <div class="row">
          <div class="col-6 q-gutter-md">
            <ul>
              <li v-html="jobsListStore.job.job_description"></li>
            </ul>

            <!-- <div>
                <p><strong>Experience</strong></p>
                <ul>
                  <li>Familiar with MVVM/MVP design</li>

                  <li>Functional reactive programming experience</li>

                  <li>Unit Testing</li>

                  <li>
                    At least 3-5 years experience (as developer) in mobile
                    development
                  </li>
                </ul>
              </div> -->
          </div>

          <div class="col"></div>

          <div class="col-5">
            <div class="q-mb-lg">
              <p>STATUS</p>
              <q-input v-model="form.application_status" filled disable />
            </div>

            <div class="q-mb-lg">
              <p>CV / RESUME</p>
              <q-file
                v-model="form.cv_or_resume"
                max-file-size="5242880"
                outlined
                disable
              >
                <template v-slot:prepend>
                  <q-icon name="eva-attach-outline" />
                </template>
              </q-file>
            </div>

            <div v-if="form.cover_letter !== null" class="q-mb-lg">
              <p>COVER LETTER</p>
              <q-input
                v-model="form.cover_letter"
                filled
                type="textarea"
                disable
              />
            </div>
          </div>
        </div>
      </q-card-section>

      <div class="row q-px-md">
        <div class="col q-mt-md">
          <span
            >POSTED {{ getDaysPosted(jobsListStore.job.created_at) }} DAYS
            AGO</span
          >
        </div>
      </div>
    </q-card>
  </q-dialog>
</template>

<script>
import { defineComponent, ref, reactive } from "vue";
import { useJobsList } from "../../../store/job";
import { useApplicationsList } from "../../../store/application";

export default defineComponent({
  props: {
    job: {
      type: Array,
      default: () => {
        return [];
      },
    },
  },
  setup(props) {
    const jobsListStore = useJobsList();
    const { getJobs, getJob } = jobsListStore;

    const applicationsListStore = useApplicationsList();
    const { getApplications, getApplication } = applicationsListStore;

    const showApplyNowDialog = ref(false);
    const showViewDetailsDialog = ref(false);
    const form = reactive({
      application_status: null,
      cover_letter: null,
      cv_or_resume: null,
    });

    const onClickApplyNow = async (id) => {
      await getJob(id);
      showApplyNowDialog.value = true;
    };

    const onClickViewDetails = async (job_id) => {
      if (props.job.is_applied === true) {
        await getJob(job_id);

        for (let x = 0; x < applicationsListStore.applications.length; x++) {
          const application = applicationsListStore.applications[x];

          if (application.job_post_id === job_id) {
            let file = application.cv_or_resume.split("/").pop();
            var blob = new Blob([file], {
              type: "application/pdf" || "application/msword",
            });

            form.cv_or_resume = new File([blob], file, {
              type: "application/pdf" || "application/msword",
            });
            form.cover_letter = application.cover_letter;
            form.application_status = application.application_status.name;
          }

          await getApplication(application.id);
        }

        showViewDetailsDialog.value = true;
      } else {
        showViewDetailsDialog.value = false;
      }
    };

    const getDaysPosted = (date) => {
      let currentDate = new Date();
      let startDate = new Date(date);

      var difference = Math.abs(currentDate - startDate);
      var numberOfDays = difference / (1000 * 3600 * 24);
      return Math.round(numberOfDays);
    };

    getApplications();

    return {
      form,
      jobsListStore,
      applicationsListStore,
      showApplyNowDialog,
      showViewDetailsDialog,
      onClickApplyNow,
      onClickViewDetails,
      getDaysPosted,
    };
  },
});
</script>

<style lang="scss" scoped>
.logo-container {
  width: 100px;
  height: 100px;
  background-color: $brand-1;
}

.salary-container {
  padding: 10px 20px 10px 20px;
}

#apply {
  width: 120px !important;
}

.q-editor {
  border-radius: 10px;
  // background: #f5f5f5;
  width: 100%;
}
</style>
